<template>
  <div>
    <v-card class="mx-auto pl-2 elevation-0" max-width="500">
      <v-list dense>
        <v-list-group
            v-model="particlesListActive"
            prepend-icon="mdi-plus-circle-multiple-outline"
            color="white"
        >
          <template v-slot:activator>
            <v-list-item-content>
              <v-list-item-title class="subtitle-1">Particles</v-list-item-title>
            </v-list-item-content>
          </template>
          <v-list-item v-for="(particle, index) in particleList" :key="index" @click="() => onParticleClick(index)">
            <span style="font-size: 0.9em; margin-right: 10px" :class="selectedParticle !== index ? 'greyFont' : ''">
              #{{ index + 1 }}
            </span>
            <v-icon :color="(() => {
              if (particle.locked) return 'grey'
              return particle.q > 0 ? 'red' : 'blue'
            })()">mdi-checkbox-blank-circle
            </v-icon>
            <div :class="selectedParticle !== index ? 'cordDisplay greyFont' : 'cordDisplay'">
              X: {{ particle.pos.x.toPrecision(2) }} m<br>
              Y: {{ particle.pos.y.toPrecision(2) }} m
            </div>
            <v-spacer></v-spacer>
            <v-btn icon small @click="() => onEditParticle(index)" :disabled="!enableActionBtn">
              <v-icon small>mdi-pencil</v-icon>
            </v-btn>
            <v-btn icon small @click="() => onDeleteParticle(index)" :disabled="!enableActionBtn">
              <v-icon small color="red">mdi-delete</v-icon>
            </v-btn>
          </v-list-item>
        </v-list-group>

        <v-list-group
            v-model="shapesListActive"
            prepend-icon="mdi-shape-outline"
            color="white"
        >
          <template v-slot:activator>
            <v-list-item-content>
              <v-list-item-title class="subtitle-1">Shapes</v-list-item-title>
            </v-list-item-content>
          </template>
          <v-list-item v-for="(shape, index) in shapeList" :key="index">
            <span style="font-size: 0.9em; margin-right: 10px">
              #{{ index + 1 }}
            </span>

            <v-icon>mdi-circle-outline</v-icon>
            <div class="cordDisplay">
              X: {{ shape.info.center_x.toPrecision(2) }} m<br>
              Y: {{ shape.info.center_y.toPrecision(2) }} m
            </div>
            <span style="margin-left: 10px; font-size: 0.8em">
              R: {{ shape.info.radius.toPrecision(2) }}
            </span>

            <v-spacer></v-spacer>
            <v-btn icon small @click="() => onEditShape(index)" :disabled="!enableActionBtn">
              <v-icon small>mdi-pencil</v-icon>
            </v-btn>
            <v-btn icon small @click="() => onDeleteShape(index)" :disabled="!enableActionBtn">
              <v-icon small color="red">mdi-delete</v-icon>
            </v-btn>
            <!-- <v-icon>mdi-checkbox-blank-circle</v-icon>
          <div :class="selectedParticle !== index ? 'cordDisplay greyFont' : 'cordDisplay'">
            X: {{ particle.pos.x.toPrecision(2) }} m<br>
            Y: {{ particle.pos.y.toPrecision(2) }} m
          </div>
          <v-spacer></v-spacer>
          <v-btn icon small @click="() => onEditParticle(index)" :disabled="!enableActionBtn">
            <v-icon small>mdi-pencil</v-icon>
          </v-btn>
          <v-btn icon small @click="() => onDeleteParticle(index)" :disabled="!enableActionBtn">
            <v-icon small color="red">mdi-delete</v-icon>
          </v-btn>-->

          </v-list-item>
        </v-list-group>
      </v-list>
    </v-card>
    <EditParticleDialog
        v-bind:show="showEditParticleDialog"
        :particle="particleToEdit"
        @canceled="showEditParticleDialog = false"
        @saved="onEditParticleSaved"
    />
    <EditCircleDialog
        v-bind:show="showEditCircleDialog"
        :circle="circleToEdit"
        @canceled="showEditCircleDialog = false"
        @saved="onEditCircleSaved"
    />
  </div>
</template>

<script>
import {AppContext} from '@Util'
import {EditParticle, EditCircle} from '@/dialogs'

const defaultParticle = {
  pos: {x: '0', y: '0'},
  q: '0',
  m: '0',
  locked: false
}

const defaultCircle = {
  info: {
    center_x: '0',
    center_y: '0',
    radius: '1e-8',
  }
}

export default {
  name: 'ElementList',
  components: {
    EditParticleDialog: EditParticle,
    EditCircleDialog: EditCircle
  },
  data: () => ({
    particleToEditId: -1,
    circleToEditId: -1,
    particleToEdit: defaultParticle,
    circleToEdit: defaultCircle,
    showEditParticleDialog: false,
    showEditCircleDialog: false,
    particlesListActive: false,
    shapesListActive: false,
  }),
  computed: {
    enableActionBtn() {
      return !AppContext.simOn
    },
    particleList() {
      return AppContext.grid?.particlesList ?? []
    },
    shapeList() {
      return AppContext.grid?.shapesList ?? []
    },
    selectedParticle() {
      return AppContext.grid.selectedElement
    }
  },
  methods: {
    onParticleClick(id) {
      AppContext.grid.selectedElement = id
      AppContext.grid.CenterOnParticleId(id)
    },
    onEditParticle(id) {
      this.particleToEditId = id
      this.particleToEdit = JSON.parse(JSON.stringify(AppContext.currentProject.particles[id]))
      this.showEditParticleDialog = true
    },
    onEditShape(id) {
      this.circleToEditId = id
      this.circleToEdit = JSON.parse(JSON.stringify(AppContext.currentProject.shapes[id]))
      this.showEditCircleDialog = true
    },
    onDeleteParticle(id) {
      AppContext.currentProject.DeleteParticle(id)
      AppContext.currentProject.Save()
    },
    onDeleteShape(id) {
      AppContext.currentProject.DeleteShape(id)
      AppContext.currentProject.Save()
    },
    onEditCircleSaved() {
      let circle = AppContext.currentProject.shapes[this.circleToEditId]
      circle.info = {
        center_x: Number(this.circleToEdit.info.center_x),
        center_y: Number(this.circleToEdit.info.center_y),
        radius: Number(this.circleToEdit.info.radius),
      }
      AppContext.currentProject.Save().then(() => this.showEditCircleDialog = false)
    },
    onEditParticleSaved() {
      let particle = AppContext.currentProject.particles[this.particleToEditId]
      particle.pos = {
        x: Number(this.particleToEdit.pos.x),
        y: Number(this.particleToEdit.pos.y)
      }
      particle.q = Number(this.particleToEdit.q)
      particle.m = Number(this.particleToEdit.m)
      particle.locked = this.particleToEdit.locked
      particle.RefreshScreenPos(AppContext.currentProject.scale)
      AppContext.currentProject.Save().then(() => this.showEditParticleDialog = false)
    }
  }
}
</script>

<style scoped>
.cordDisplay {
  margin-left: 10px;
  line-height: normal;
  font-size: 0.9em
}

.greyFont {
  color: grey;
}
</style>
